/*
**  ObjCCommentHandler.m
**
**  Copyright (c) 2003
**
**  Author: Yen-Ju  <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ObjCCommentHandler.h"
#include <Foundation/Foundation.h>

@implementation ObjCCommentHandler

- (void) string: (NSString *) element
{
}

- (void) number: (NSString *) element 
{
}

- (void) spaceAndNewLine: (NSString *) element 
{
  if (_commentType == SingleLineComment)
    {
      if ( EQUAL(@"\n") || EQUAL(@"\r") )
        {
          _commentType = NoComment;
        }
    }
}

- (void) symbol: (NSString *) element 
{
  if ( EQUAL(@"*") && [_preString isEqualToString: @"/"] ) 
    {
      _commentType = MultipleLineComment;
    }
  else if ( EQUAL(@"/") && [_preString isEqualToString: @"/"] ) 
    {
      _commentType = SingleLineComment;
    }
  else if ( EQUAL(@"/") && [_preString isEqualToString: @"*"] )
    {
      _commentType = NoComment;
    }
  else
    {
      if (_commentType != NoComment)
        {
        }
      else if EQUAL(@"\"")
        {
          if (_stringBegin == YES)
            _stringBegin = NO;
          else
            _stringBegin = YES;
        }
    }
}

- (void) invisible: (NSString *) element
{
}

- (id) init
{
  self = [super init];
  _commentType = NoComment;
  _stringBegin = NO;
  return self;
}

@end

